## fcitx5-gtk 0.0~git20191111.6f9ef64

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
set(FCITX5_GTK_VERSION 4.99.0)
project(fcitx5-gtk VERSION ${FCITX5_GTK_VERSION})

find_package(ECM REQUIRED 1.0.0)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

include(FindPkgConfig)
include(ECMSetupVersion)
include(GenerateExportHeader)
include(FeatureSummary)
include(GNUInstallDirs)
include(FcitxCompilerSettings)
include(ECMUninstallTarget)

option(ENABLE_GIR "GObject Introspection" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" ON)
option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" ON)

if(NOT NO_SNOOPER_APPS)
  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
    CACHE STRING "Disable Key Snooper for following app")
endif()

configure_file(config.h.in "${CMAKE_CURRENT_BINARY_DIR}/config.h")
include_directories("${CMAKE_CURRENT_BINARY_DIR}")
find_package(PkgConfig)
find_package(XKBCommon)
find_package(Fcitx5Utils)
pkg_check_modules(GLib2 REQUIRED IMPORTED_TARGET "glib-2.0")
pkg_check_modules(Gio2 REQUIRED IMPORTED_TARGET "gio-2.0")
pkg_check_modules(GObject2 REQUIRED IMPORTED_TARGET "gobject-2.0")
add_subdirectory(fcitx-gclient)

if (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE)
find_package(X11 REQUIRED)
add_library(X11Import UNKNOWN IMPORTED)
set_target_properties(X11Import PROPERTIES
    IMPORTED_LOCATION "${X11_X11_LIB}"
    INTERFACE_INCLUDE_DIRECTORIES "${X11_X11_INCLUDE_PATH}")
endif()

if (ENABLE_GTK2_IM_MODULE)
add_subdirectory(gtk2)
endif()

if (ENABLE_GTK3_IM_MODULE)
add_subdirectory(gtk3)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== fcitx-gclient/CMakeLists.txt ===
set(FCITX_GCLIENT_SOURCES
  fcitxgwatcher.c
  fcitxgclient.c
  )

set(FCITX_GCLIENT_BUILT_SOURCES
  ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
  )

set(FCITX_GCLIENT_HEADERS
  fcitxgclient.h
  fcitxgwatcher.h
  )

set(FCITX_GCLIENT_BUILT_HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
  )

pkg_get_variable(GLIB2_GLIB_GENMARSHAL "glib-2.0" "glib_genmarshal")
find_program(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})

add_custom_command(OUTPUT marshall.c
  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list > marshall.c
  DEPENDS ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list)
add_custom_command(OUTPUT marshall.h
  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
  ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list > marshall.h
  DEPENDS ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list)

add_library(Fcitx5GClient SHARED ${FCITX_GCLIENT_SOURCES}
  ${FCITX_GCLIENT_BUILT_SOURCES} ${FCITX_GCLIENT_BUILT_HEADERS})
set_target_properties(Fcitx5GClient
  PROPERTIES VERSION 1.0
  SOVERSION 1
  COMPILE_FLAGS "-fvisibility=hidden"
  LINK_FLAGS "-Wl,--no-undefined"
  EXPORT_NAME GClient
  )
target_include_directories(Fcitx5GClient PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..;${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}>/Fcitx5/GClient")
target_link_libraries(Fcitx5GClient PRIVATE PkgConfig::Gio2 PkgConfig::GLib2 PkgConfig::GObject2)

configure_file(Fcitx5GClient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClient.pc @ONLY)

install(TARGETS Fcitx5GClient EXPORT Fcitx5GClientTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClient.pc
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/GClient/fcitx-gclient")

add_library(Fcitx5::GClient ALIAS Fcitx5GClient)

ecm_setup_version(PROJECT
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfigVersion.cmake"
                  SOVERSION 1)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/Fcitx5GClientConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfig.cmake"
                              INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5GClient
)

    generate_export_header(Fcitx5GClient BASE_NAME FcitxGClient)

install(EXPORT Fcitx5GClientTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5GClient FILE Fcitx5GClientTargets.cmake NAMESPACE Fcitx5::)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfigVersion.cmake"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5GClient
        COMPONENT Devel )

if(ENABLE_GIR)
  include(GObjectIntrospection)
  gobject_introspection(
    FILENAME FcitxG-1.0.gir
    NSVERSION 1.0
    INCLUDE Gio-2.0 GObject-2.0 GLib-2.0
    PACKAGE_EXPORT Fcitx5GClient
    LIBRARY Fcitx5GClient
    NAMESPACE FcitxG
    SCANNER_ARGS --warn-all --add-include-path=${CMAKE_CURRENT_SOURCE_DIR}
    COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}"
    SYMBOL_PREFIXES fcitx_g
    SOURCES ${FCITX_GCLIENT_SOURCES} ${FCITX_GCLIENT_HEADERS}
    QUIET
    )
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/FcitxG-1.0.gir"
    DESTINATION "${GOBJECT_INTROSPECTION_GIRDIR}")
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/FcitxG-1.0.typelib"
    DESTINATION "${GOBJECT_INTROSPECTION_TYPELIBDIR}")
endif()

=== gtk2/CMakeLists.txt ===
set(FCITX_GTK2_IM_MODULE_SOURCES
  fcitxim.c
  fcitximcontext.cpp
  )

pkg_check_modules(Gtk2 REQUIRED IMPORTED_TARGET "gtk+-2.0")
pkg_check_modules(Gdk2 REQUIRED IMPORTED_TARGET "gdk-2.0")
pkg_check_modules(Gdk2X11 REQUIRED IMPORTED_TARGET "gdk-x11-2.0")
pkg_get_variable(GTK2_BINARY_VERSION "gtk+-2.0" "gtk_binary_version")

if (NOT DEFINED GTK2_IM_MODULEDIR)
    set(GTK2_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules" CACHE PATH "Gtk2 im module directory")
endif()

set(FCITX_GTK2_IM_MODULE_SOURCES ${FCITX_GTK2_IM_MODULE_SOURCES})

add_library(im-fcitx5 MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
set_target_properties( im-fcitx5 PROPERTIES PREFIX ""
  COMPILE_FLAGS "-fvisibility=hidden -fno-exceptions" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries(im-fcitx5 Fcitx5::Utils Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk2 PkgConfig::Gdk2 PkgConfig::Gdk2X11 X11Import)
install(TARGETS im-fcitx5 DESTINATION "${GTK2_IM_MODULEDIR}")

=== gtk3/CMakeLists.txt ===
set(FCITX_GTK3_IM_MODULE_SOURCES
  fcitxim.c
  fcitximcontext.cpp
  )

pkg_check_modules(Gtk3 REQUIRED IMPORTED_TARGET "gtk+-3.0")
pkg_check_modules(Gdk3 REQUIRED IMPORTED_TARGET "gdk-3.0")
pkg_check_modules(Gdk3X11 REQUIRED IMPORTED_TARGET "gdk-x11-3.0")
pkg_get_variable(GTK3_BINARY_VERSION "gtk+-3.0" "gtk_binary_version")

if (NOT DEFINED GTK3_IM_MODULEDIR)
    set(GTK3_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules" CACHE PATH "Gtk3 im module directory")
endif()

set(FCITX_GTK3_IM_MODULE_SOURCES ${FCITX_GTK3_IM_MODULE_SOURCES})

add_library(im-fcitx5-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties(im-fcitx5-gtk3 PROPERTIES PREFIX "" OUTPUT_NAME "im-fcitx5"
  COMPILE_FLAGS "-fvisibility=hidden -fno-exceptions" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries(im-fcitx5-gtk3 Fcitx5::Utils Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk3 PkgConfig::Gdk3 PkgConfig::Gdk3X11 X11Import)
install(TARGETS im-fcitx5-gtk3 DESTINATION "${GTK3_IM_MODULEDIR}")

=== debian/changelog ===
fcitx5-gtk (0.0~git20191111.6f9ef64-2) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.5.0.
  * Source-only upload to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Wed, 05 Feb 2020 16:54:09 -0500

fcitx5-gtk (0.0~git20191111.6f9ef64-1) unstable; urgency=medium

  * Initial release. (Closes: #949345)

 -- Boyuan Yang <byang@debian.org>  Mon, 25 Nov 2019 23:10:27 -0500

=== debian/control ===
Source: fcitx5-gtk
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.6.0),
 debhelper-compat (= 12),
 extra-cmake-modules,
 gobject-introspection,
 libfcitx5utils-dev,
 libgirepository1.0-dev,
 libgtk-3-dev,
 libgtk2.0-dev,
 libx11-dev,
 libxkbcommon-dev,
 libxkbcommon-x11-dev,
 pkg-config,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/fcitx/fcitx5-gtk
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5-gtk.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5-gtk

Package: gir1.2-fcitxg-1.0
Section: introspection
Architecture: linux-any
Multi-Arch: same
Depends:
 ${gir:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Description: GObject introspection data for fcitx5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package contains introspection data for Fcitx5.
 It can be used by packages using the GIRepository format to generate
 dynamic bindings.

Package: libfcitx5gclient1
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GLib-based D-Bus client library for fcitx5 (library)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the GLib-based D-Bus client library of fcitx5.

Package: libfcitx5gclient-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 gir1.2-fcitxg-1.0 (= ${binary:Version}),
 ${misc:Depends},
Description: GLib-based D-Bus client library for fcitx5 (development files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the development files for GLib-based D-Bus client
 library of fcitx5.

Package: fcitx5-frontend-gtk3
Section: utils
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GTK3 IM Module for fcitx5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the im module of fcitx5. Users of GTK3-based
 applications are highly recommended to have this package installed
 for better input method support.

Package: fcitx5-frontend-gtk2
Section: utils
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GTK2 IM Module for fcitx5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the im module of fcitx5. Users of GTK2-based
 applications are highly recommended to have this package installed
 for better input method support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with gir

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
 https://github.com/fcitx/fcitx5-gtk.git \
  HEAD debian uupdate

## fcitx5-gtk 0.0~git20200819.d26dd52

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,6 @@
 include(GenerateExportHeader)
 include(FeatureSummary)
 include(GNUInstallDirs)
-include(FcitxCompilerSettings)
 include(ECMUninstallTarget)
 
 option(ENABLE_GIR "GObject Introspection" ON)
@@ -18,20 +17,24 @@
 option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" ON)
 option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" ON)
 
-if(NOT NO_SNOOPER_APPS)
-  set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
-    CACHE STRING "Disable Key Snooper for following app")
-endif()
+set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
+    CACHE STRING "Disable Key Snooper for following app by default.")
+set(NO_PREEDIT_APPS "gvim.*" CACHE STRING "Disable preedit for follwing app by default.")
+set(SYNC_MODE_APPS "firefox.*" CACHE STRING "Use sync mode for following app by default.")
 
 configure_file(config.h.in "${CMAKE_CURRENT_BINARY_DIR}/config.h")
 include_directories("${CMAKE_CURRENT_BINARY_DIR}")
 find_package(PkgConfig)
 find_package(XKBCommon)
 find_package(Fcitx5Utils)
-pkg_check_modules(GLib2 REQUIRED IMPORTED_TARGET "glib-2.0")
+pkg_check_modules(GLib2 REQUIRED IMPORTED_TARGET "glib-2.0>=2.38")
 pkg_check_modules(Gio2 REQUIRED IMPORTED_TARGET "gio-2.0")
 pkg_check_modules(GObject2 REQUIRED IMPORTED_TARGET "gobject-2.0")
 add_subdirectory(fcitx-gclient)
+
+set(CMAKE_C_VISIBILITY_PRESET default)
+
+include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
 if (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE)
 find_package(X11 REQUIRED)

=== fcitx-gclient/CMakeLists.txt ===
--- 
+++ 
@@ -20,11 +20,11 @@
 find_program(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})
 
 add_custom_command(OUTPUT marshall.c
-  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall
+  COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall --internal --include-header=marshall.h
   ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list > marshall.c
   DEPENDS ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list)
 add_custom_command(OUTPUT marshall.h
-  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall
+  COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall --internal
   ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list > marshall.h
   DEPENDS ${PROJECT_SOURCE_DIR}/gtk-common/marshall.list)
 
@@ -33,21 +33,25 @@
 set_target_properties(Fcitx5GClient
   PROPERTIES VERSION 1.0
   SOVERSION 1
-  COMPILE_FLAGS "-fvisibility=hidden"
-  LINK_FLAGS "-Wl,--no-undefined"
   EXPORT_NAME GClient
+  C_VISIBILITY_PRESET default
   )
-target_include_directories(Fcitx5GClient PUBLIC
-    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..;${CMAKE_CURRENT_BINARY_DIR}>"
-    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}>/Fcitx5/GClient")
-target_link_libraries(Fcitx5GClient PRIVATE PkgConfig::Gio2 PkgConfig::GLib2 PkgConfig::GObject2)
+target_include_directories(Fcitx5GClient
+    PUBLIC
+        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..;${CMAKE_CURRENT_BINARY_DIR}>"
+        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}>/Fcitx5/GClient"
+    INTERFACE
+        "${Gio2_INCLUDE_DIRS}"
+        "${GObject2_INCLUDE_DIRS}"
+)
+target_link_libraries(Fcitx5GClient LINK_PRIVATE PkgConfig::Gio2 PkgConfig::GLib2 PkgConfig::GObject2)
 
 configure_file(Fcitx5GClient.pc.in ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClient.pc @ONLY)
 
 install(TARGETS Fcitx5GClient EXPORT Fcitx5GClientTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClient.pc
   DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
-install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/GClient/fcitx-gclient")
+install(FILES ${FCITX_GCLIENT_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/GClient/fcitx-gclient")
 
 add_library(Fcitx5::GClient ALIAS Fcitx5GClient)
 
@@ -59,8 +63,6 @@
                               "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfig.cmake"
                               INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5GClient
 )
-
-    generate_export_header(Fcitx5GClient BASE_NAME FcitxGClient)
 
 install(EXPORT Fcitx5GClientTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Fcitx5GClient FILE Fcitx5GClientTargets.cmake NAMESPACE Fcitx5::)

=== gtk2/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,6 @@
 
 add_library(im-fcitx5 MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
 set_target_properties( im-fcitx5 PROPERTIES PREFIX ""
-  COMPILE_FLAGS "-fvisibility=hidden -fno-exceptions" LINK_FLAGS "-Wl,--no-undefined")
+  COMPILE_FLAGS "-fno-exceptions")
 target_link_libraries(im-fcitx5 Fcitx5::Utils Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk2 PkgConfig::Gdk2 PkgConfig::Gdk2X11 X11Import)
 install(TARGETS im-fcitx5 DESTINATION "${GTK2_IM_MODULEDIR}")

=== gtk3/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,6 @@
 
 add_library(im-fcitx5-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
 set_target_properties(im-fcitx5-gtk3 PROPERTIES PREFIX "" OUTPUT_NAME "im-fcitx5"
-  COMPILE_FLAGS "-fvisibility=hidden -fno-exceptions" LINK_FLAGS "-Wl,--no-undefined")
+  COMPILE_FLAGS "-fno-exceptions")
 target_link_libraries(im-fcitx5-gtk3 Fcitx5::Utils Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk3 PkgConfig::Gdk3 PkgConfig::Gdk3X11 X11Import)
 install(TARGETS im-fcitx5-gtk3 DESTINATION "${GTK3_IM_MODULEDIR}")

=== debian/changelog ===
fcitx5-gtk (0.0~git20200819.d26dd52-1) unstable; urgency=medium

  * Team upload.

  [ Shengjing Zhu ]
  * New upstream snapshot
  * as-needed LDFLAGS is not needed since bullseye
  * Change architecture from linux-any to any
  * Update libfcitx5gclient1.symbols

  [ Boyuan Yang ]
  * debian/copyright: Consolidate copyright information

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 26 Aug 2020 12:01:39 +0800

fcitx5-gtk (0.0~git20200606.fc335f1-2) unstable; urgency=medium

  * Team upload.
  * Add libbrotli-dev to Build-Depends

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 03 Jul 2020 13:22:37 +0800

fcitx5-gtk (0.0~git20200606.fc335f1-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot. (Closes: #957197)
  * Bump debhelper-compat to 13 and clean up d/rules
  * Bump libfcitx5utils-dev to 0.0~git20200626
  * Add missing libfcitx5gclient headers

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 02 Jul 2020 11:52:34 +0800

fcitx5-gtk (0.0~git20200402.3e6795d-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * Add libfcitx5gclient1.symbols

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 10 Apr 2020 22:36:11 +0800

fcitx5-gtk (0.0~git20200319.22d30ef-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 24 Mar 2020 03:59:23 +0800

fcitx5-gtk (0.0~git20200312.d36d72d-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot.
  * Fix lintian: binary-control-field-duplicates-source

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 13 Mar 2020 15:48:17 +0800

=== debian/control ===
Source: fcitx5-gtk
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.6.0),
 debhelper-compat (= 13),
 extra-cmake-modules,
 gobject-introspection,
 libbrotli-dev,
 libfcitx5utils-dev (>= 0.0~git20200626),
 libgirepository1.0-dev,
 libgtk-3-dev,
 libgtk2.0-dev,
 libx11-dev,
 libxkbcommon-dev,
 libxkbcommon-x11-dev,
 pkg-config,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/fcitx/fcitx5-gtk
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5-gtk.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5-gtk

Package: fcitx5-frontend-gtk2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GTK2 IM Module for fcitx5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the im module of fcitx5. Users of GTK2-based
 applications are highly recommended to have this package installed
 for better input method support.

Package: fcitx5-frontend-gtk3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GTK3 IM Module for fcitx5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the im module of fcitx5. Users of GTK3-based
 applications are highly recommended to have this package installed
 for better input method support.

Package: gir1.2-fcitxg-1.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends:
 ${gir:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Description: GObject introspection data for fcitx5
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package contains introspection data for Fcitx5.
 It can be used by packages using the GIRepository format to generate
 dynamic bindings.

Package: libfcitx5gclient-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 gir1.2-fcitxg-1.0 (= ${binary:Version}),
 ${misc:Depends},
Description: GLib-based D-Bus client library for fcitx5 (development files)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the development files for GLib-based D-Bus client
 library of fcitx5.

Package: libfcitx5gclient1
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GLib-based D-Bus client library for fcitx5 (library)
 Fcitx5 is the next generation of fcitx input method framework. It
 provides plasant and modern input experience with intuitive graphical
 configuration tools. The framework is highly extensible with support
 for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
 environments and a developer-friendly API.
 .
 Some of its new features include support of both Wayland and Xorg
 and the ability to mimic IBus Input Method Framework in order to
 provide better compatibility across different Linux distributions
 and desktop environments.
 .
 This package provides the GLib-based D-Bus client library of fcitx5.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
 https://github.com/fcitx/fcitx5-gtk \
  HEAD debian

## fcitx5-gtk 5.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,5 @@
 cmake_minimum_required(VERSION 3.6)
-set(FCITX5_GTK_VERSION 4.99.0)
-project(fcitx5-gtk VERSION ${FCITX5_GTK_VERSION})
+project(fcitx5-gtk VERSION 5.0.3)
 
 find_package(ECM REQUIRED 1.0.0)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -15,6 +14,7 @@
 option(ENABLE_GIR "GObject Introspection" ON)
 option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
 option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" ON)
+option(ENABLE_GTK4_IM_MODULE "Enable GTK4 IM Module" ON)
 option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" ON)
 
 set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
@@ -26,7 +26,6 @@
 include_directories("${CMAKE_CURRENT_BINARY_DIR}")
 find_package(PkgConfig)
 find_package(XKBCommon)
-find_package(Fcitx5Utils)
 pkg_check_modules(GLib2 REQUIRED IMPORTED_TARGET "glib-2.0>=2.38")
 pkg_check_modules(Gio2 REQUIRED IMPORTED_TARGET "gio-2.0")
 pkg_check_modules(GObject2 REQUIRED IMPORTED_TARGET "gobject-2.0")
@@ -34,9 +33,9 @@
 
 set(CMAKE_C_VISIBILITY_PRESET default)
 
-include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
+include(cmake/CompilerSettings.cmake)
 
-if (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE)
+if (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE OR ENABLE_GTK4_IM_MODULE)
 find_package(X11 REQUIRED)
 add_library(X11Import UNKNOWN IMPORTED)
 set_target_properties(X11Import PROPERTIES
@@ -52,4 +51,8 @@
 add_subdirectory(gtk3)
 endif()
 
+if (ENABLE_GTK4_IM_MODULE)
+add_subdirectory(gtk4)
+endif()
+
 feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== fcitx-gclient/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,11 @@
   ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
   )
 
+ecm_setup_version(PROJECT
+                  VARIABLE_PREFIX Fcitx5GClient
+                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfigVersion.cmake"
+                  SOVERSION 1)
+
 pkg_get_variable(GLIB2_GLIB_GENMARSHAL "glib-2.0" "glib_genmarshal")
 find_program(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})
 
@@ -31,8 +36,8 @@
 add_library(Fcitx5GClient SHARED ${FCITX_GCLIENT_SOURCES}
   ${FCITX_GCLIENT_BUILT_SOURCES} ${FCITX_GCLIENT_BUILT_HEADERS})
 set_target_properties(Fcitx5GClient
-  PROPERTIES VERSION 1.0
-  SOVERSION 1
+  PROPERTIES VERSION ${Fcitx5GClient_VERSION}
+  SOVERSION ${Fcitx5GClient_SOVERSION}
   EXPORT_NAME GClient
   C_VISIBILITY_PRESET default
   )
@@ -54,10 +59,6 @@
 install(FILES ${FCITX_GCLIENT_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/Fcitx5/GClient/fcitx-gclient")
 
 add_library(Fcitx5::GClient ALIAS Fcitx5GClient)
-
-ecm_setup_version(PROJECT
-                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfigVersion.cmake"
-                  SOVERSION 1)
 
 configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/Fcitx5GClientConfig.cmake.in"
                               "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfig.cmake"

=== gtk2/CMakeLists.txt ===
--- 
+++ 
@@ -12,10 +12,8 @@
     set(GTK2_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules" CACHE PATH "Gtk2 im module directory")
 endif()
 
-set(FCITX_GTK2_IM_MODULE_SOURCES ${FCITX_GTK2_IM_MODULE_SOURCES})
-
 add_library(im-fcitx5 MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
 set_target_properties( im-fcitx5 PROPERTIES PREFIX ""
   COMPILE_FLAGS "-fno-exceptions")
-target_link_libraries(im-fcitx5 Fcitx5::Utils Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk2 PkgConfig::Gdk2 PkgConfig::Gdk2X11 X11Import)
+target_link_libraries(im-fcitx5 Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk2 PkgConfig::Gdk2 PkgConfig::Gdk2X11 X11Import)
 install(TARGETS im-fcitx5 DESTINATION "${GTK2_IM_MODULEDIR}")

=== gtk3/CMakeLists.txt ===
--- 
+++ 
@@ -12,10 +12,8 @@
     set(GTK3_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules" CACHE PATH "Gtk3 im module directory")
 endif()
 
-set(FCITX_GTK3_IM_MODULE_SOURCES ${FCITX_GTK3_IM_MODULE_SOURCES})
-
 add_library(im-fcitx5-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
 set_target_properties(im-fcitx5-gtk3 PROPERTIES PREFIX "" OUTPUT_NAME "im-fcitx5"
   COMPILE_FLAGS "-fno-exceptions")
-target_link_libraries(im-fcitx5-gtk3 Fcitx5::Utils Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk3 PkgConfig::Gdk3 PkgConfig::Gdk3X11 X11Import)
+target_link_libraries(im-fcitx5-gtk3 Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk3 PkgConfig::Gdk3 PkgConfig::Gdk3X11 X11Import)
 install(TARGETS im-fcitx5-gtk3 DESTINATION "${GTK3_IM_MODULEDIR}")

=== gtk4/CMakeLists.txt ===
set(FCITX_GTK4_IM_MODULE_SOURCES
  fcitxim.c
  fcitximcontext.cpp
  )

pkg_check_modules(Gtk4 REQUIRED IMPORTED_TARGET "gtk4")
pkg_check_modules(Gtk4X11 REQUIRED IMPORTED_TARGET "gtk4-x11")
pkg_get_variable(GTK4_BINARY_VERSION "gtk4" "gtk_binary_version")

if (NOT DEFINED GTK4_IM_MODULEDIR)
    set(GTK4_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-4.0/${GTK4_BINARY_VERSION}/immodules" CACHE PATH "Gtk4 im module directory")
endif()

add_library(im-fcitx5-gtk4 MODULE ${FCITX_GTK4_IM_MODULE_SOURCES})
set_target_properties(im-fcitx5-gtk4 PROPERTIES OUTPUT_NAME "im-fcitx5"
  COMPILE_FLAGS "-fno-exceptions")
target_link_libraries(im-fcitx5-gtk4 Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk4 PkgConfig::Gtk4X11 X11Import)
install(TARGETS im-fcitx5-gtk4 DESTINATION "${GTK4_IM_MODULEDIR}")

=== debian/changelog ===
fcitx5-gtk (5.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Disable GTK4 for now.
  * Update Standards-Version to 4.5.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 16 Jan 2021 01:45:19 +0800

fcitx5-gtk (5.0.1-2) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Remove libfcitx5utils-dev from Build-Depends
  * Fix libfcitx5gclient1.install file match

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 05 Dec 2020 18:29:41 +0800

fcitx5-gtk (5.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump libfcitx5utils-dev to 5.0.1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 07 Nov 2020 00:10:37 +0800

fcitx5-gtk (0.0~git20200912.8835e96-1) unstable; urgency=medium

  * Team upload.
  * New upstream snapshot
  * Bump libfcitx5utils-dev to 0.0~git20201030
  * Add patch to align libfcitx5gclient version with soversion
  * Update libfcitx5gclient1.symbols

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 31 Oct 2020 22:57:16 +0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
  extra-cmake-modules,
  gobject-introspection,
  libbrotli-dev,
- libfcitx5utils-dev (>= 0.0~git20200626),
  libgirepository1.0-dev,
  libgtk-3-dev,
  libgtk2.0-dev,
@@ -19,7 +18,7 @@
  libxkbcommon-x11-dev,
  pkg-config,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/fcitx/fcitx5-gtk
 Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5-gtk.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5-gtk

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with gir

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_GTK4_IM_MODULE=OFF

## fcitx5-gtk 5.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.6)
-project(fcitx5-gtk VERSION 5.0.3)
+project(fcitx5-gtk VERSION 5.0.4)
 
 find_package(ECM REQUIRED 1.0.0)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

## fcitx5-gtk 5.0.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.6)
-project(fcitx5-gtk VERSION 5.0.4)
+project(fcitx5-gtk VERSION 5.0.11)
 
 find_package(ECM REQUIRED 1.0.0)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -14,7 +14,7 @@
 option(ENABLE_GIR "GObject Introspection" ON)
 option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
 option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" ON)
-option(ENABLE_GTK4_IM_MODULE "Enable GTK4 IM Module" ON)
+option(ENABLE_GTK4_IM_MODULE "Enable GTK4 IM Module" OFF)
 option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" ON)
 
 set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
@@ -26,7 +26,7 @@
 include_directories("${CMAKE_CURRENT_BINARY_DIR}")
 find_package(PkgConfig)
 find_package(XKBCommon)
-pkg_check_modules(GLib2 REQUIRED IMPORTED_TARGET "glib-2.0>=2.38")
+pkg_check_modules(GLib2 REQUIRED IMPORTED_TARGET "glib-2.0>=2.56")
 pkg_check_modules(Gio2 REQUIRED IMPORTED_TARGET "gio-2.0")
 pkg_check_modules(GObject2 REQUIRED IMPORTED_TARGET "gobject-2.0")
 add_subdirectory(fcitx-gclient)

=== gtk3/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,10 @@
 set(FCITX_GTK3_IM_MODULE_SOURCES
   fcitxim.c
   fcitximcontext.cpp
+  fcitxtheme.cpp
+  utils.cpp
+  inputwindow.cpp
+  gtk3inputwindow.cpp
   )
 
 pkg_check_modules(Gtk3 REQUIRED IMPORTED_TARGET "gtk+-3.0")

=== gtk4/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,14 @@
 set(FCITX_GTK4_IM_MODULE_SOURCES
   fcitxim.c
   fcitximcontext.cpp
+  fcitximcontext5.cpp
+  inputwindow.cpp
+  gtk4inputwindow.cpp
+  fcitxtheme.cpp
+  utils.cpp
   )
 
-pkg_check_modules(Gtk4 REQUIRED IMPORTED_TARGET "gtk4")
+pkg_check_modules(Gtk4 REQUIRED IMPORTED_TARGET "gtk4>=4.2")
 pkg_check_modules(Gtk4X11 REQUIRED IMPORTED_TARGET "gtk4-x11")
 pkg_get_variable(GTK4_BINARY_VERSION "gtk4" "gtk_binary_version")

=== debian/changelog ===
fcitx5-gtk (5.0.11.1-1) unstable; urgency=medium

  * update

 -- Debian Input Method Team <debian-input-method@lists.debian.org>  Wed, 09 Mar 2022 16:57:25 +0800

fcitx5-gtk (5.0.11-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Jan 2022 12:57:06 -0500

fcitx5-gtk (5.0.10-1) unstable; urgency=medium

  * New upstream release 5.0.10.

 -- Boyuan Yang <byang@debian.org>  Tue, 14 Dec 2021 14:48:02 -0500

fcitx5-gtk (5.0.9-1) unstable; urgency=medium

  * New upstream release 5.0.9.

 -- Boyuan Yang <byang@debian.org>  Wed, 24 Nov 2021 10:55:33 -0500

fcitx5-gtk (5.0.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Fix typo in package description

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 01 Oct 2021 02:37:01 +0800

fcitx5-gtk (5.0.7-2) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Thu, 09 Sep 2021 19:58:15 -0400

fcitx5-gtk (5.0.7-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update Standards-Version to 4.6.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 25 Aug 2021 02:49:15 +0800

fcitx5-gtk (5.0.4-2) experimental; urgency=medium

  * Team upload.
  * Enable building gtk4 frontend

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 19 Feb 2021 22:56:21 +0800

fcitx5-gtk (5.0.4-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Add libfmt-dev to Build-Depends
  * Bump libfcitx5gclient SO to 2

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 19 Feb 2021 22:45:32 +0800

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,11 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake (>= 3.6.0),
- debhelper-compat (= 13),
+ debhelper-compat (= 12),
  extra-cmake-modules,
  gobject-introspection,
  libbrotli-dev,
+ libfmt-dev,
  libgirepository1.0-dev,
  libgtk-3-dev,
  libgtk2.0-dev,
@@ -18,7 +19,7 @@
  libxkbcommon-x11-dev,
  pkg-config,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/fcitx/fcitx5-gtk
 Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5-gtk.git
 Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5-gtk
@@ -31,7 +32,7 @@
  ${shlibs:Depends},
 Description: GTK2 IM Module for fcitx5
  Fcitx5 is the next generation of fcitx input method framework. It
- provides plasant and modern input experience with intuitive graphical
+ provides pleasant and modern input experience with intuitive graphical
  configuration tools. The framework is highly extensible with support
  for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
  environments and a developer-friendly API.
@@ -53,7 +54,7 @@
  ${shlibs:Depends},
 Description: GTK3 IM Module for fcitx5
  Fcitx5 is the next generation of fcitx input method framework. It
- provides plasant and modern input experience with intuitive graphical
+ provides pleasant and modern input experience with intuitive graphical
  configuration tools. The framework is highly extensible with support
  for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
  environments and a developer-friendly API.
@@ -77,7 +78,7 @@
  ${shlibs:Depends},
 Description: GObject introspection data for fcitx5
  Fcitx5 is the next generation of fcitx input method framework. It
- provides plasant and modern input experience with intuitive graphical
+ provides pleasant and modern input experience with intuitive graphical
  configuration tools. The framework is highly extensible with support
  for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
  environments and a developer-friendly API.
@@ -100,7 +101,7 @@
  ${misc:Depends},
 Description: GLib-based D-Bus client library for fcitx5 (development files)
  Fcitx5 is the next generation of fcitx input method framework. It
- provides plasant and modern input experience with intuitive graphical
+ provides pleasant and modern input experience with intuitive graphical
  configuration tools. The framework is highly extensible with support
  for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
  environments and a developer-friendly API.
@@ -113,7 +114,7 @@
  This package provides the development files for GLib-based D-Bus client
  library of fcitx5.
 
-Package: libfcitx5gclient1
+Package: libfcitx5gclient2
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -122,7 +123,7 @@
  ${shlibs:Depends},
 Description: GLib-based D-Bus client library for fcitx5 (library)
  Fcitx5 is the next generation of fcitx input method framework. It
- provides plasant and modern input experience with intuitive graphical
+ provides pleasant and modern input experience with intuitive graphical
  configuration tools. The framework is highly extensible with support
  for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
  environments and a developer-friendly API.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
 https://github.com/fcitx/fcitx5-gtk \
  refs/tags/@ANY_VERSION@ debian

## fcitx5-gtk 5.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.6)
-project(fcitx5-gtk VERSION 5.0.11)
+project(fcitx5-gtk VERSION 5.0.12)
 
 find_package(ECM REQUIRED 1.0.0)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
@@ -14,7 +14,7 @@
 option(ENABLE_GIR "GObject Introspection" ON)
 option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
 option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" ON)
-option(ENABLE_GTK4_IM_MODULE "Enable GTK4 IM Module" OFF)
+option(ENABLE_GTK4_IM_MODULE "Enable GTK4 IM Module" ON)
 option(ENABLE_SNOOPER "Enable Key Snooper for gtk app" ON)
 
 set(NO_SNOOPER_APPS ".*chrome.*,.*chromium.*,firefox.*,Do.*"
@@ -35,12 +35,42 @@
 
 include(cmake/CompilerSettings.cmake)
 
-if (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE OR ENABLE_GTK4_IM_MODULE)
-find_package(X11 REQUIRED)
-add_library(X11Import UNKNOWN IMPORTED)
-set_target_properties(X11Import PROPERTIES
-    IMPORTED_LOCATION "${X11_X11_LIB}"
-    INTERFACE_INCLUDE_DIRECTORIES "${X11_X11_INCLUDE_PATH}")
+set(NEED_X11 FALSE)
+if (ENABLE_GTK2_IM_MODULE)
+    pkg_check_modules(Gtk2 REQUIRED IMPORTED_TARGET "gtk+-2.0")
+    pkg_check_modules(Gdk2 REQUIRED IMPORTED_TARGET "gdk-2.0")
+    pkg_check_modules(Gdk2X11 REQUIRED IMPORTED_TARGET "gdk-x11-2.0")
+    pkg_get_variable(GTK2_BINARY_VERSION "gtk+-2.0" "gtk_binary_version")
+    set(NEED_X11 TRUE)
+endif()
+
+if (ENABLE_GTK3_IM_MODULE)
+    pkg_check_modules(Gtk3 REQUIRED IMPORTED_TARGET "gtk+-3.0")
+    pkg_check_modules(Gdk3 REQUIRED IMPORTED_TARGET "gdk-3.0")
+    pkg_get_variable(GTK3_BINARY_VERSION "gtk+-3.0" "gtk_binary_version")
+    pkg_get_variable(GTK3_TARGETS "gtk+-3.0" "targets")
+    if (GTK3_TARGETS MATCHES "x11")
+        set(NEED_X11 TRUE)
+        pkg_check_modules(Gdk3X11 REQUIRED IMPORTED_TARGET "gdk-x11-3.0")
+    endif()
+endif()
+
+if (ENABLE_GTK4_IM_MODULE)
+    pkg_check_modules(Gtk4 REQUIRED IMPORTED_TARGET "gtk4>=4.2")
+    pkg_get_variable(GTK4_BINARY_VERSION "gtk4" "gtk_binary_version")
+    pkg_get_variable(GTK4_TARGETS "gtk4" "targets")
+    if (GTK4_TARGETS MATCHES "x11")
+        set(NEED_X11 TRUE)
+        pkg_check_modules(Gtk4X11 REQUIRED IMPORTED_TARGET "gtk4-x11")
+    endif()
+endif()
+
+if (NEED_X11)
+    find_package(X11 REQUIRED)
+    add_library(X11Import UNKNOWN IMPORTED)
+    set_target_properties(X11Import PROPERTIES
+        IMPORTED_LOCATION "${X11_X11_LIB}"
+        INTERFACE_INCLUDE_DIRECTORIES "${X11_X11_INCLUDE_PATH}")
 endif()
 
 if (ENABLE_GTK2_IM_MODULE)

=== fcitx-gclient/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 ecm_setup_version(PROJECT
                   VARIABLE_PREFIX Fcitx5GClient
                   PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/Fcitx5GClientConfigVersion.cmake"
-                  SOVERSION 1)
+                  SOVERSION 2)
 
 pkg_get_variable(GLIB2_GLIB_GENMARSHAL "glib-2.0" "glib_genmarshal")
 find_program(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})

=== gtk2/CMakeLists.txt ===
--- 
+++ 
@@ -2,11 +2,6 @@
   fcitxim.c
   fcitximcontext.cpp
   )
-
-pkg_check_modules(Gtk2 REQUIRED IMPORTED_TARGET "gtk+-2.0")
-pkg_check_modules(Gdk2 REQUIRED IMPORTED_TARGET "gdk-2.0")
-pkg_check_modules(Gdk2X11 REQUIRED IMPORTED_TARGET "gdk-x11-2.0")
-pkg_get_variable(GTK2_BINARY_VERSION "gtk+-2.0" "gtk_binary_version")
 
 if (NOT DEFINED GTK2_IM_MODULEDIR)
     set(GTK2_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules" CACHE PATH "Gtk2 im module directory")

=== gtk3/CMakeLists.txt ===
set(FCITX_GTK3_IM_MODULE_SOURCES
  fcitxim.c
  fcitximcontext.cpp
  fcitxtheme.cpp
  utils.cpp
  inputwindow.cpp
  gtk3inputwindow.cpp
  )

if (NOT DEFINED GTK3_IM_MODULEDIR)
    set(GTK3_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules" CACHE PATH "Gtk3 im module directory")
endif()

add_library(im-fcitx5-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties(im-fcitx5-gtk3 PROPERTIES PREFIX "" OUTPUT_NAME "im-fcitx5"
  COMPILE_FLAGS "-fno-exceptions")

target_link_libraries(im-fcitx5-gtk3 Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk3)
if (TARGET PkgConfig::Gdk3X11)
target_link_libraries(im-fcitx5-gtk3 PkgConfig::Gdk3X11 X11Import)
endif()

install(TARGETS im-fcitx5-gtk3 DESTINATION "${GTK3_IM_MODULEDIR}")

=== gtk4/CMakeLists.txt ===
set(FCITX_GTK4_IM_MODULE_SOURCES
  fcitxim.c
  fcitximcontext.cpp
  fcitximcontext5.cpp
  inputwindow.cpp
  gtk4inputwindow.cpp
  fcitxtheme.cpp
  utils.cpp
  )

if (NOT DEFINED GTK4_IM_MODULEDIR)
    set(GTK4_IM_MODULEDIR "${CMAKE_INSTALL_LIBDIR}/gtk-4.0/${GTK4_BINARY_VERSION}/immodules" CACHE PATH "Gtk4 im module directory")
endif()

add_library(im-fcitx5-gtk4 MODULE ${FCITX_GTK4_IM_MODULE_SOURCES})
set_target_properties(im-fcitx5-gtk4 PROPERTIES OUTPUT_NAME "im-fcitx5"
  COMPILE_FLAGS "-fno-exceptions")
target_link_libraries(im-fcitx5-gtk4 Fcitx5::GClient XKBCommon::XKBCommon PkgConfig::Gtk4)
if (TARGET PkgConfig::Gtk4X11)
    target_link_libraries(im-fcitx5-gtk4 PkgConfig::Gtk4X11 X11Import)
endif()
install(TARGETS im-fcitx5-gtk4 DESTINATION "${GTK4_IM_MODULEDIR}")

=== debian/changelog ===
fcitx5-gtk (5.0.12-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 02 Feb 2022 10:46:35 -0500

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,14 @@
  Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake (>= 3.6.0),
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  extra-cmake-modules,
  gobject-introspection,
  libbrotli-dev,
  libfmt-dev,
  libgirepository1.0-dev,
  libgtk-3-dev,
+ libgtk-4-dev,
  libgtk2.0-dev,
  libx11-dev,
  libxkbcommon-dev,
@@ -65,6 +66,28 @@
  and desktop environments.
  .
  This package provides the im module of fcitx5. Users of GTK3-based
+ applications are highly recommended to have this package installed
+ for better input method support.
+
+Package: fcitx5-frontend-gtk4
+Architecture: any
+Multi-Arch: same
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Description: GTK4 IM Module for fcitx5
+ Fcitx5 is the next generation of fcitx input method framework. It
+ provides pleasant and modern input experience with intuitive graphical
+ configuration tools. The framework is highly extensible with support
+ for GTK+ and Qt toolkits, DBus interfaces, a large variety of desktop
+ environments and a developer-friendly API.
+ .
+ Some of its new features include support of both Wayland and Xorg
+ and the ability to mimic IBus Input Method Framework in order to
+ provide better compatibility across different Linux distributions
+ and desktop environments.
+ .
+ This package provides the im module of fcitx5. Users of GTK4-based
  applications are highly recommended to have this package installed
  for better input method support.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with gir
